#include "keypad.h"
#include <avr/io.h>
#include <util/delay.h>

int keypressed;

void keypad_init()
{
    keypressed = 0;
    KEYPAD_DDR = 0xF0;

    _delay_ms(1);

    KEYPAD_PORT = 0x0F;
}


char keypad_read()
{
    if (KEYPAD_PIN != 0b11110000)
    {
        _delay_ms(5);
        keypressed = KEYPAD_PIN;
        KEYPAD_DDR ^= 0b11111111;
        _delay_ms(1);
        KEYPAD_PORT ^= 0b11111111;
        _delay_ms(1);
        keypressed |= KEYPAD_PIN;

        //col 1
        if (255 - keypressed == 0b00010001)
        {
            return '1';
        }
        if (255 - keypressed == 0b00010010)
        {
            return '4';
        }
        if (255 - keypressed == 0b00010100)
        {
            return '7';
        }
        if (255 - keypressed == 0b00011000)
        {
            return '*';
        }
        //col 2
        if (255 - keypressed == 0b00100001)
        {
            return '2';
        }
        if (255 - keypressed == 0b00100010)
        {
            return '5';
        }
        if (255 - keypressed == 0b00100100)
        {
            return '8';
        }
        if (255 - keypressed == 0b00101000)
        {
            return '0';
        }
        //col 3
        if (255 - keypressed == 0b01000001)
        {
            return '3';
        }
        if (255 - keypressed == 0b01000010)
        {
            return '6';
        }
        if (255 - keypressed == 0b01000100)
        {
            return '9';
        }
        if (255 - keypressed == 0b01001000)
        {
            return '#';
        }
        //col 4
        if (255 - keypressed == 0b10000001)
        {
            return 'A';
        }
        if (255 - keypressed == 0b10000010)
        {
            return 'B';
        }
        if (255 - keypressed == 0b10000100)
        {
            return 'C';
        }
        if (255 - keypressed == 0b10001000)
        {
            return 'D';
        }
    }

    
    return 0;
}

void keypad_reset()
{
    keypressed=0;
	KEYPAD_DDR ^=0b11111111;
	_delay_ms(1);
	KEYPAD_PORT ^= 0b11111111;
}