/*
 * Proiectarea cu microprocesoare
 * Ultimate Tic Tac Toe
 * Macovei Alexandra Oana - 332CA
 */

#include <avr/io.h>
#include <util/delay.h>
#include <stdio.h>
#include <stdint.h>
#include <avr/pgmspace.h>
#include <stdbool.h>
#include <inttypes.h>
#include "ili9341.h"
#include "ili9341gfx.h"
#include "keypad.h"
#include <stdlib.h>

extern uint16_t vsetx, vsety, vactualx, vactualy, isetx, isety, iactualx, iactualy;
static FILE mydata = FDEV_SETUP_STREAM(ili9341_putchar_printf, NULL, _FDEV_SETUP_WRITE);

int mat[10][10];
int finalmat[4][4];
int global_start_x = 20;
int global_start_y = 20;

int currentPlayer;
int cadran = -1;
int oldcadran;

void init_mat()
{
	int i, j;
	for(i=1; i<=9; i++)
	{
		for(j=1; j<=9; j++)
		{
			mat[i][j] = -1;
			if((i < 4) && (j<4) )
				finalmat[i][j] = -1;
		}
	}

}

int getWinner(int mat[10][10], int startx, int starty)
{
	/* check lines */
	if((mat[starty][startx] == mat[starty][startx+1]) && (mat[starty][startx+1] == mat[starty][startx+2])
		&& mat[starty][startx] != -1) return mat[starty][startx];

	if((mat[starty+1][startx] == mat[starty+1][startx+1]) && (mat[starty+1][startx+1] == mat[starty+1][startx+2])
		&& mat[starty+1][startx] != -1) return mat[starty+1][startx];

	if((mat[starty+2][startx] == mat[starty+2][startx+1]) && (mat[starty+2][startx+1] == mat[starty+2][startx+2])
		&& mat[starty+2][startx] != -1) return mat[starty+2][startx];

	/* check columns */
	if((mat[starty][startx] == mat[starty+1][startx]) && (mat[starty+1][startx] == mat[starty+2][startx])
		&& mat[starty][startx] != -1) return mat[starty][startx];

	if((mat[starty][startx+1] == mat[starty+1][startx+1]) && (mat[starty+1][startx+1] == mat[starty+2][startx+1])
		&& mat[starty][startx+1] != -1) return mat[starty][startx+1];

	if((mat[starty][startx+2] == mat[starty+1][startx+2]) && (mat[starty+1][startx+2] == mat[starty+2][startx+2])
		&& mat[starty][startx+2] != -1) return mat[starty][startx+2];

	/* check diagonals */
	if((mat[starty][startx] == mat[starty+1][startx+1]) && (mat[starty+1][startx+1] == mat[starty+2][startx+2])
		&& mat[starty][startx] != -1) return mat[starty][startx];

	if((mat[starty][startx+2] == mat[starty+1][startx+1]) && (mat[starty+1][startx+1] == mat[starty+2][startx])
		&& mat[starty][startx+2] != -1) return mat[starty][startx+2];


	return -1;

}

void print_local(int startx, int starty, int color)
{
	int i, j;
	for(i=0; i<3; i++)
	{
		for(j=0; j<3; j++)
		{
			ili9341_drawrect(startx + i *20, starty+j*20, 20, 20, color, 1);
		}
	}
}

void print_global(int startx, int starty)
{
	int i, j;
	for(i=0; i<3; i++)
	{
		for(j=0; j<3; j++)
		{
			print_local(startx + i *65, starty+j*65, RED);
		}
	}
}

void print_elem(int y, int x, int color)
{
	int offset = 5;
	int xpos = global_start_x + (x-1) * 20 + 4;
	if( x > 3) xpos+=offset;
	if( x > 6) xpos+=offset;

	int ypos = global_start_y + (y-1) * 20 + 2;
	if( y > 3) ypos+=offset;
	if( y > 6) ypos+=offset;

	if(currentPlayer == 0)
		ili9341_drawchar(xpos, ypos, 'o' ,color, BLACK, 2);
	else
		ili9341_drawchar(xpos, ypos, 'x' ,color, BLACK, 2);
}

void print_cel(int y, int x, int color, char elem)
{
	int offset = 5;
	int xpos = global_start_x + (x-1) * 20 + 4;
	if( x > 3) xpos+=offset;
	if( x > 6) xpos+=offset;

	int ypos = global_start_y + (y-1) * 20 + 2;
	if( y > 3) ypos+=offset;
	if( y > 6) ypos+=offset;
	ili9341_drawchar(xpos, ypos, elem ,color, BLACK, 2);
}


void printtext(char msg[200], int x, int y, int size, int color, int back)
{
	ili9341_settextsize(size);	
	ili9341_setcursor(x,y);
	ili9341_settextcolour(color, back);
	printf(msg);
}

void printCurrentPlayer()
{
	if(currentPlayer == 0)
	{
		printtext("Player O:", 220, 60, 1, WHITE, BLACK );
		printtext("Enter coords:", 220, 80, 1, WHITE, BLACK );
		if(cadran != -1){
			printtext("IN CADRAN: ", 220, 100, 1, RED, BLACK );
			ili9341_drawchar(290, 100, cadran + '0', RED, BLACK, 2);

		}
	}
	if(currentPlayer == 1)
	{
		printtext("Player X:", 220, 60, 1, WHITE, BLACK );
		printtext("Enter coords:", 220, 80, 1, WHITE, BLACK );
		if(cadran != -1){
			printtext("IN CADRAN: ", 220, 100, 1, RED, BLACK );
			ili9341_drawchar(290, 100, cadran + '0', RED, BLACK, 2);
		}

	}
}

void print_invalid_choice()
{
	printtext("INVALID!", 220, 200, 2, RED, BLACK );
}
void clear_invalid_choice()
{
	printtext("INVALID!", 220, 200, 2, BLACK, BLACK );
}

int get_in_cadran(int y, int x)
{
	return ((y-1)%3)*3 + (x-1)%3 + 1;
}
int generated_cadran(int y, int x)
{
	if(y > 3 ) y = y % 3;
	if(x >3 )  x = x % 3;
	if( x == 0) x = 3;
	if( y == 0) y = 3;

	return get_in_cadran(y, x);
}


int cadPos(int y, int x)
{
	return ((y-1)/3)*3 + (x-1)/3+1;
}

int check_cadran(int number)
{
	int startx, starty;
	if(number == 1)	{		
		starty = 1;
		startx = 1;
	}
	if(number == 2)	{		
		starty = 1;
		startx = 4;
	}
		if(number == 3)	{		
		starty = 1;
		startx = 7;
	}
		if(number == 4)	{		
		starty = 4;
		startx = 1;
	}
		if(number == 5)	{		
		starty = 4;
		startx = 4;
	}
		if(number == 6)	{		
		starty = 4;
		startx = 7;
	}
		if(number == 7)	{		
		starty = 7;
		startx = 1;
	}
		if(number == 8)	{		
		starty = 7;
		startx = 4;
	}
		if(number == 9)	{		
		starty = 7;
		startx = 7;
	}

	int i, j;
	int result = getWinner(mat, startx, starty);
	if(result != -1)
	{
		wrtietofinal(number, result);
		for(i = starty; i<starty+3; i++)
		{
			for(j = startx; j<startx+3; j++)
			{
				if(result == 0)
				{

					if(mat[i][j] == 0) {
						print_cel(i, j,YELLOW, 'o');
					}
					if(mat[i][j] == 1) {
						print_cel(i, j,YELLOW, 'x');
					}
				}
				if(result == 1)
				{
					if(mat[i][j] == 0) {
						print_cel(i, j,GREEN, 'o');
					}
					if(mat[i][j] == 1) {
						print_cel(i, j,GREEN, 'x');
					}
				}

			}
		}
	}
	return result;

}

void wrtietofinal(int number, int value)
{
	if(number == 1) finalmat[1][1] = value;
	if(number == 2) finalmat[1][2] = value;
	if(number == 3) finalmat[1][3] = value;
	if(number == 4) finalmat[2][1] = value;
	if(number == 5) finalmat[2][2] = value;
	if(number == 6) finalmat[2][3] = value;
	if(number == 7) finalmat[3][1] = value;
	if(number == 8) finalmat[3][2] = value;
	if(number == 9) finalmat[3][3] = value;
}

int main()
{
	char key;
	stdout = &mydata;
	ili9341_init();
	ili9341_clear(BLACK);
	keypad_init();
	ili9341_setRotation(1);	
	print_global(global_start_x, global_start_y);
	int i, j;

	currentPlayer = 1;
	printtext("X & 0", 230, 30, 2, WHITE, BLACK );
	init_mat();
		
	int x, y;

	while(1) {
		printCurrentPlayer();

		for(i=1; i<=9; i++)
			check_cadran(i);

		if(getWinner(finalmat, 1, 1) != -1) {
			printtext("GAME OVER", 40, 220, 1, RED, BLACK );
			break;
		}
		while(1) {
			key = keypad_read();
			if(key >= '0' && key <= '9') {
				y = key - '0';
				ili9341_drawchar(230, 150, key, RED, BLACK, 2);
				break;
			}
		}

		_delay_ms(500);

		while(1) {
			key = keypad_read();
			if(key >= '0' && key <= '9') {
				x = key - '0';
				ili9341_drawchar(250, 150, key, RED, BLACK, 2);
				break;
			}
		}


		_delay_ms(1000);

		if((check_cadran(cadPos(y,x)) == -1) && (mat[y][x] == -1) && ((cadPos(y,x) == cadran) || (cadran == -1)) ) {
			
			oldcadran = cadran;
			cadran = generated_cadran(y, x);
			mat[y][x] = currentPlayer;
			print_elem(y, x, WHITE);
			_delay_ms(500);
			
			if(currentPlayer == 1) currentPlayer = 0;
			else currentPlayer = 1;
		}
		else
		{
			print_invalid_choice();
			_delay_ms(500);
			clear_invalid_choice();
		}

		ili9341_drawchar(230, 150, y+'0', BLACK, BLACK, 2);
		ili9341_drawchar(250, 150, x+'0', BLACK, BLACK, 2);

		if(check_cadran(cadran) != -1)
		{
			ili9341_drawchar(290, 100, oldcadran + '0', BLACK, BLACK, 2);
			cadran = -1;
		}

	}
		
	return 0;
}

